#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var program = require("commander");
var index_1 = require("./index");
program
    .option('-e, --entry [path]', '<path|glob> …')
    .option('-r, --sourceRoot [path]', 'Source root directory.')
    .option('-d, --dataDir [path]', 'Output directory for data.')
    .option('-l, --localesDir [path]', 'Output directory for locales.')
    .option('-f, --localesFile [name]', 'Filename for locales.')
    .option('-w, --watch', 'watch mode')
    .option('-v, --verbose', 'output extra debugging');
program.parse(process.argv);
if (program.verbose) {
    console.log(program.opts());
}
var options = {};
if (program.entry) {
    options.source = program.entry;
}
if (program.sourceRoot) {
    options.sourceRoot = program.sourceRoot;
}
if (program.dataDir) {
    options.dataDir = program.dataDir;
}
if (program.localesDir) {
    options.localesDir = program.localesDir;
}
if (program.localesFile) {
    options.localesFile = program.localesFile;
}
index_1.default(options);
