"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var chalk = require('chalk'); // tslint:disable-line
var fs = require("fs");
var fse = require("fs-extra");
var globby = require("globby");
var path = require("path");
function isIterable(value) {
    var type = Object.prototype.toString.call(value);
    return type === '[object Object]' || type === '[object Array]';
}
function parser(source, delimiter) {
    if (delimiter === void 0) { delimiter = '.'; }
    var data = __assign({}, source);
    var locales = {};
    function parse(object, prev) {
        Object.keys(object).forEach(function (key) {
            var value = object[key];
            var newKey = prev ? prev + delimiter + key : key;
            if (isIterable(value) && Object.keys(value).length) {
                return parse(value, newKey);
            }
            if (key.match(/^\$.+/)) {
                var i = newKey.lastIndexOf(key);
                var localeStr = newKey.slice(0, i) + newKey.slice(i + 1);
                object[key] = localeStr;
                newKey = localeStr;
                locales[newKey] = value;
            }
        });
    }
    parse(data);
    return { data: data, locales: locales };
}
exports.parser = parser;
function writeData(filepath, filename, json) {
    return new Promise(function (resolve) {
        fse.outputFile(filepath, json, function (err) {
            /* istanbul ignore next */
            if (err) {
                throw err;
            }
            console.log("\uD83D\uDCE6 " + chalk.green('Data have been saved!') + " [" + filename + "]");
            resolve();
        });
    });
}
function writeLocales(filepath, filename, json) {
    return new Promise(function (resolve) {
        fs.writeFile(filepath, json, function (err) {
            /* istanbul ignore next */
            if (err) {
                throw err;
            }
            console.log("\uD83D\uDCAC " + chalk.green('Locales have been saved!') + " [" + filename + "]");
            resolve();
        });
    });
}
function updateLocales(filepath, filename, data) {
    return new Promise(function (resolve) {
        var locales = require(filepath);
        Object.keys(data).forEach(function (key) {
            /* istanbul ignore else */
            if (locales[key] === undefined) {
                locales[key] = data[key];
            }
        });
        var sortedLocales = {};
        Object.keys(locales)
            .sort()
            .forEach(function (key) {
            sortedLocales[key] = locales[key];
        });
        fs.writeFile(filepath, JSON.stringify(sortedLocales, null, 2), function (err) {
            /* istanbul ignore next */
            if (err) {
                throw err;
            }
            console.log("\uD83D\uDCAC " + chalk.green('Locales have been updated!') + " [" + filename + "]");
            resolve();
        });
    });
}
function run(_a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.source, source = _c === void 0 ? 'data.js' : _c, _d = _b.sourceRoot, sourceRoot = _d === void 0 ? '' : _d, _e = _b.dataDir, dataDir = _e === void 0 ? 'data' : _e, _f = _b.localesDir, localesDir = _f === void 0 ? 'locales' : _f, _g = _b.localesFile, localesFile = _g === void 0 ? 'locales' : _g, _h = _b.delimiter, delimiter = _h === void 0 ? '.' : _h;
    return __awaiter(this, void 0, void 0, function () {
        var dest, locales, entries, localesPaths, localesData;
        var _this = this;
        return __generator(this, function (_j) {
            switch (_j.label) {
                case 0:
                    dest = {
                        data: path.resolve(process.cwd(), dataDir),
                        locales: path.resolve(process.cwd(), localesDir),
                    };
                    locales = {};
                    // Check/create destination directories
                    Object.keys(dest).forEach(function (key) {
                        try {
                            /* istanbul ignore else */
                            if (!fs.existsSync(dest[key])) {
                                fs.mkdirSync(dest[key]);
                            }
                            console.info(key.toUpperCase() + " directory: " + chalk.yellow(dest[key]));
                        }
                        catch (err) {
                            /* istanbul ignore next */
                            console.error(err);
                        }
                    });
                    if (!isIterable(source)) return [3 /*break*/, 1];
                    entries = [source];
                    return [3 /*break*/, 3];
                case 1: return [4 /*yield*/, globby(source)];
                case 2:
                    entries = _j.sent();
                    _j.label = 3;
                case 3:
                    entries.forEach(function (entry) { return __awaiter(_this, void 0, void 0, function () {
                        var _a, dir, base, name, ext, raw, _b, data, newLocales, filePath, root;
                        return __generator(this, function (_c) {
                            switch (_c.label) {
                                case 0:
                                    _a = isIterable(entry)
                                        ? {
                                            base: 'data.json',
                                            dir: '',
                                            ext: 'json',
                                            name: 'data',
                                        }
                                        : path.parse(entry), dir = _a.dir, base = _a.base, name = _a.name, ext = _a.ext;
                                    raw = isIterable(entry)
                                        ? entry
                                        : require(path.resolve(process.cwd(), entry));
                                    _b = parser(raw, delimiter), data = _b.data, newLocales = _b.locales;
                                    // Merge locales
                                    locales = __assign({}, locales, newLocales);
                                    filePath = name + ".json";
                                    if (sourceRoot !== '' && !isIterable(entry)) {
                                        root = sourceRoot.replace(/\/$/, '') + "/";
                                        filePath = entry.replace(root, '').replace(/\.js$/, '.json');
                                    }
                                    return [4 /*yield*/, writeData(path.join(dest.data, filePath), filePath, JSON.stringify(data, null, 2))];
                                case 1:
                                    _c.sent();
                                    return [2 /*return*/];
                            }
                        });
                    }); });
                    return [4 /*yield*/, globby(dest.locales + "/*.json")];
                case 4:
                    localesPaths = _j.sent();
                    localesData = JSON.stringify(locales, null, 2);
                    if (!(localesPaths.length > 0)) return [3 /*break*/, 5];
                    localesPaths.forEach(function (localesPath) { return __awaiter(_this, void 0, void 0, function () {
                        var base;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    base = path.parse(localesPath).base;
                                    return [4 /*yield*/, updateLocales(localesPath, base, locales)];
                                case 1:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    }); });
                    return [3 /*break*/, 7];
                case 5: return [4 /*yield*/, writeLocales(path.join(dest.locales, localesFile + ".json"), localesFile + ".json", localesData)];
                case 6:
                    _j.sent();
                    _j.label = 7;
                case 7: return [2 /*return*/];
            }
        });
    });
}
exports.default = run;
